using System;
using System.Drawing;

namespace Photo_Editor_Application
{
    /// <summary>
    /// The text component is responsible for drawing
    /// text to the drawing surface.
    /// </summary>
    /// <requirement>F:image_text_annotations</requirement>
    public class TextComponent : GraphicsComponent
    {
        /// <summary>
        /// Constructor for text Component.
        /// </summary>
        public TextComponent()
        {

        }
        /// <summary>
        /// Accessor for textInput which represents the 
        /// text to be drawn.
        /// </summary>
        public string TextInput
        {
            get 
            {
                return textInput;
            }
            set
            {
                textInput = value;
            }
        }

        /// <summary>
        /// Draws the text into the Graphics object provided.
        /// </summary>
        public override void Draw()
        {
            Font ff = new Font("Arial",18);
            Point tempPoint = new Point(StartPoint.X, StartPoint.Y);
            tempPoint = CalcViewportCoords(tempPoint);
            DeviceContext.DrawString(textInput, ff, Brushes.Black, 
                tempPoint.X, tempPoint.Y);
            // Dispose the font created
            ff.Dispose();
        }

        private string textInput;
    }

}
